/* You may find the license in the LICENSE file */
 
var DTA_TBB = {
	init: function() {
		this._items = ['button', 'turbo-button', 'manager-button', 'toolbar-spacer'].map(function(e) document.getElementById('dta-' + e));
		let before = this._items.map(
			function(e) e.hasAttribute('insertbefore') ? {b: e, e: document.getElementById(e.getAttribute('insertbefore'))} : null
		);
		for each (let e in before) {
			if (!e || !e.e) {
				continue;
			}
			if (e.b.previousSibling.id != e.e.id) {
				e.e.parentNode.insertBefore(e.b, e.e);
			}
		}
		DTA.Preferences.addObserver("extensions.dta.tb.", this);
		this._refresh();
	},
	observe: function(subject, topic, prefName) {
		this._refresh();
	},
	_refresh: function() {
		DTA.Preferences
			.getExt('tb.buttons')
			.split(',')
			.forEach(
				function(v, i) {
					this._items[i].hidden = v != '1';
				},
				this
			);
	}
};
window.addEventListener("load", function() DTA_TBB.init() || true, false);